/* analysieren des Hamiltoniens hxy.tmp 
 *   - anzahl doppelter elemente
 *   - anzahl verschiedener matrixelemente
 *   - max. spaltenzahl 
 *   # was ist mit letzte zeile mit feof(hxy), zeile richtig erkannt?
 *   # try small matrix mit wenig speicher! 
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#if 0
typedef float zahl;
#else
typedef double zahl;
#endif
typedef unsigned long ulong;

#define N  512
#define N1 12870
#define HXY "/tmp/hxy.tmp"
#define H2  "/tmp/h2.tmp"
#define NZ 122694

void sort(ulong *n,ulong y,zahl r,ulong *ll,zahl *lr){
    ulong i,j;
    for(i=0l;i<(*n);i++){
      if(ll[i]==y){lr[i]+=r;break;}
      if(ll[i]> y){
        for(j=(*n);j>i;j--){ll[j]=ll[j-1];lr[j]=lr[j-1];}
        ll[i]=y;lr[i]=r;(*n)++;break;
      }
    }
    if(i==(*n)){ll[i]=y;lr[i]=r;(*n)++;}
    return;}

ulong l1[N],   /* liste anzahl verschiedener hxy-entrys */
      l2[N1],l3[N1],l4[N1],ly[N1];
zahl  r1[N],r2[N1],r3[N1],r4[N1];

int main(){         
   ulong n1=N1,x=0l,y,i1,i3=0l,i4=0l,i5=0l,maxy=0l,ny=0l,dy=0l,
         fpos,		/* file position */
         i2=0l;
   ulong t1,t2,i6,i,nx,warn=0l;
   zahl r,eps=1e-14; /* genauigkeit float */
   FILE *f1,*f2;
   setvbuf(stdout, (char *)NULL, _IONBF, 0);	/* nicht puffern!	*/
   if(!(f1=fopen(HXY,"rb")))printf("error openHXY\n");
   if(!(f2=fopen(H2 ,"wb")))printf("error createH\n");fclose(f2);
   ly[0l]=0l;nx=0l;
   for(t1=0l;(!feof(f1)) && t1<NZ;t1++){
      if((t1*100l)%NZ==0l){printf("%lu ",(t1*100l)/NZ);}
      if(t1%100l==0l)printf("%lu\r",t1);
      fread(&y,sizeof(ulong),1,f1);
      fread(&r,sizeof(zahl) ,1,f1);
      /* printf(" %20ld %20f\n",(long)y,(double)r); */

      /* neue zeile? */
      if(y>=n1){
        i4=0;
        if(!(f2=fopen(H2 ,"r+b")))printf("error openHrw\n");
        for(t2=0l;t2<nx;t2++){
          for(i=0l;i<ly[t2];i++){               /* zeile laden */
            fread(&l4[i],sizeof(ulong),1,f2);
            fread(&r4[i],sizeof(zahl) ,1,f2);}
                                     /* compare beide zeilen! */
          for(i=0l;i<ny;i++)
            if(l4[i]!=l3[i] || fabs(r4[i]-r3[i])>eps)break;
          if(i==i4){dy++;break;}} 	 	/* zeile doppelt */
        if(t2==nx){ 				/* neue zeile feof(f2) */
           for(i=0l;i<ny;i++){
              fwrite(&l3[i],sizeof(ulong),1,f2);
              fwrite(&r3[i],sizeof(zahl) ,1,f2);}
           ly[nx]=ny;nx++;}
        fclose(f2);
      }

      /* neue zeile? */
      if((y>=n1) || feof(f1)){y%=n1;x++;i5=i3=ny=0l;}
      sort(&i5,y,r,l3,r3);
      ny++;if(ny>maxy)maxy=ny;

      for(i1=0l;i1<i2;i1++)if(fabs(r1[i1]-r)<eps){l1[i1]++;break;}
      if(i1>=i2)if(i2<N){l1[i2]=1l;r1[i2]=r;i2++;}else warn|=1l;

      for(i1=0l;i1<i3;i1++)if(fabs(r2[i1]-r)<eps)if(l2[i1]==y){ i6++;break;}
      if(i1>=i3)if(i3<N1){l2[i3]=y;r2[i3]=r;i3++;} else warn|=2l;
      
    }
   fclose(f1);
   for(i1=0l;i1<i2;i1++)
     printf(" %10lu %10lu * %20e\n",i1,l1[i1],(double)r1[i1]);
   printf(" Anzahl doppelter entries %10lu von %lu\n",i6,t1);
   printf(" max. zahl elemente/zeile %10lu\n",maxy);
   printf(" doppelte zeilen          %10lu\n",dy);
   printf(" anzahl versch. zeilen    %10lu\n",nx);
   if(warn)printf(" Warn %lu\n",warn);  
   return 0;}


